<?php
ob_start();
require_once '../../../wp-config.php';
require_once 'simplepie.inc.php';
require_once 'subscriptions.php';
include_once '../../../wp-admin/admin-header.php';


//$feed = new SimplePie();
$feed = new BukoPie();
$feed->cache_max_minutes(360); // 6 hours - markku
$feed->bypass_image_hotlink();
$feed->replace_headers(true);
$feed->strip_ads(true);

// Make sure that page is getting passed a URL
if (!empty($_GET['feed'])) {

	// Use the URL that was passed to the page in SimplePie
	$feed->feed_url($_GET['feed']);
}

$feed->init();
$feed->handle_content_type();

$f = new feeds;
$f->load('');


$current_tag = trim(urldecode($_GET['tag']));
$tqs = '&tag='.urlencode($current_tag);


if ($_GET['op'] == 'clear-cache') {
    $rss_url = trim(urldecode($_GET['feed']));
    $feed->clear_cache_item();
    header('Location:'.$_SERVER['SCRIPT_URI'].'?'.$tqs.'&feed='.urlencode($rss_url).'#feed');
}


if ($_GET['op'] == 'add') {
    $new['rss_url'] = trim(urldecode($_GET['feed']));
    $new['title'] = trim(urldecode($_GET['title']));
    $new['tags'] = array();

    $f->add($new);
    $f->save();
    header('Location:'.$_SERVER['SCRIPT_URI'].'?'.$tqs.'&feed='.urlencode($new['rss_url']).'#feed');
}

if ($_GET['op'] == 'delete') {
    $rss_url = trim(urldecode($_GET['feed']));
    $f->delete($rss_url);
    $f->save();
    header('Location:'.$_SERVER['SCRIPT_URI'].'?'.$tqs);
}


if ($_GET['op'] == 'remove-tag') {
    $rss_url = trim(urldecode($_GET['feed']));
    $delete_tag = trim(urldecode($_GET['tag']));
    $f->remove_tag($rss_url,$delete_tag);
    $f->save();
    header('Location:'.$_SERVER['SCRIPT_URI'].'?'.$tqs.'&feed='.urlencode($rss_url).'#feed');
}



if (isset($_POST['edit_title'])) {
    $rss_url = trim(urldecode($_POST['feed']));
    $title = stripslashes($_POST['new_title']);
    $f->update_title($rss_url, $title);
    $f->save();
    header('Location:?'.$tqs.'&feed='.urlencode($rss_url).'#feed');
}

if (isset($_POST['add_tag'])) {
    $rss_url = trim(urldecode($_POST['feed']));
    $new_tag = stripslashes($_POST['newtag']);
    if (strlen($new_tag) > 0) {
        $f->add_tag($rss_url, $new_tag);
        $f->save();
    }
    header('Location:?'.$tqs.'&feed='.urlencode($rss_url).'#feed');
}

$current_feed = $f->get_feed(trim($_GET['feed']));
$items = $f->get_feeds();
$tags = $f->get_tags();
if (count($tags) > 0) {
    sort($tags);
}


if (count($items) > 0) {
    for ($i=0; $i < count($items); $i++) {
        $items[$i]['sort'] = strtolower($items[$i]['title']);
        $sorted[] = array_reverse($items[$i]);
    }
    sort($sorted);
    $items = $sorted;
}

//ob_flush();
$oout = ob_get_clean();
echo $oout;
?>

<div class="wrap" id="bukopie">
<div id="site">


    <h2>BukoPie</h2>



		<div id="" class="chunk">
			<form action="" method="get" name="sp_form" id="sp_form">
				<div id="sp_input">


					<!-- If a feed has already been passed through the form, then make sure that the URL remains in the form field. -->
					<p><strong>Feed URL:</strong>&nbsp;<input type="text" name="feed" value="<?php if ($feed->subscribe_url()) echo $feed->subscribe_url(); ?>" class="text" id="feed_input" />&nbsp;<input type="submit" value="Read" class="button" /></p>


				</div>
			</form>


			<?php
			// Check to see if there are more than zero errors (i.e. if there are any errors at all)
			if (isset($feed->error)) {

				// If so, start a <div> element with a classname so we can style it.
				echo '<div class="sp_errors">' . "\r\n";

					// ... and display it.
					echo "<p>$feed->error</p>\r\n";

				// Close the <div> element we opened.
				echo '</div>' . "\r\n";
			}
			?>





<?php
if (count($tags) > 0) { ?>
			<p class="globals"><strong>Tags:</strong>
        <?php if ( !isset($current_tag) || strlen($current_tag) == 0) { ?>
            <span><a href="?tag=">show all</a></span> &nbsp;
        <?php } else { ?>
            (<a href="?tag=">show all</a>) &nbsp;
        <?php } ?>
    <?php
    foreach ($tags as $tag) {
        if ($current_tag == $tag) {
            echo '<span><a href="?tag='.urlencode($tag).'">'.$tag.'</a></span> &nbsp; '."\n";
        } else {
            echo '<a href="?tag='.urlencode($tag).'">'.$tag.'</a> &nbsp; '."\n";
        }
    }
    ?>
            </p>
    <?php
}
?>




<?php
$is_subscribed = false;
$beg_span = '';
$end_span = '';
if (count($items) > 0) { ?>
			<p class="globals"><strong>Subscribed feeds:</strong> 
    <?php
    foreach ($items as $item) {
        if (strtolower(trim($_GET['feed'])) == strtolower(trim($item['rss_url']))) {
            $is_subscribed = true;
            $beg_span = '<span>';
            $end_span = '</span>';
        }
        if (strlen($current_tag) > 0) { // tag view
            if (in_array($current_tag, $item['tags'])) {
                echo $beg_span.'<a href="?'.$tqs.'&amp;feed='.urlencode($item['rss_url']).'#feed">'.$item['title'].'</a>'.$end_span.' &nbsp; '."\n";
                $beg_span = '';
                $end_span = '';
            }
        } else { // all feeds
            echo $beg_span.'<a href="?'.$tqs.'&amp;feed='.urlencode($item['rss_url']).'#feed">'.$item['title'].'</a>'.$end_span.' &nbsp; '."\n";
            $beg_span = '';
            $end_span = '';
        }
    }
    ?>
            </p>
    <?php
}
?>
			<a name="feed"></a>
		</div>





		<div id="sp_results">


			<!-- As long as the feed has data to work with... -->
			<?php if ($feed->data): ?>
				<div class="chunk focus" align="center">

					<!-- If the feed has a link back to the site that publishes it (which 99% of them do), link the feed's title to it. -->
					<h3 class="header"><?php if ($feed->get_feed_link()) echo '<a href="' . $feed->get_feed_link() . '">'; echo $feed->get_feed_title(); if ($feed->get_feed_link()) echo '</a>'; ?></h3>

					<!-- If the feed has a description, display it. -->
					<?php echo $feed->get_feed_description(); ?>

				</div>

                <?php if (count($current_feed['tags']) > 0) { ?>
                <div id="feed-tags">
                <?php
                sort($current_feed['tags']);
                foreach ($current_feed['tags'] as $tag) {
                    echo '<a href="?tag='.urlencode($tag).'">'.$tag.'</a>'
                         .' (<a class="del" href="?op=remove-tag&amp;feed='.$current_feed['rss_url'].'&amp;tag='.urlencode($tag).'">x</a>)'
                         .'&nbsp; '."\n";
                }
                ?>
                </div>
                <?php } ?>


				<div id="options">
                <a href="javascript:;" onclick="toggleClassCookie('div','rss-excerpts');return false;">Toggle all excerpts</a>
                &#183; <?php if (!$is_subscribed) { ?><a href="?op=add&amp;feed=<?php echo urlencode($feed->rss_url); ?>&amp;title=<?php echo urlencode($feed->get_feed_title()); ?>">Subscribe</a><?php } else { ?><a href="?op=delete&amp;feed=<?php echo urlencode($feed->rss_url); ?>&amp;title=<?php echo urlencode($feed->get_feed_title()); ?>">Unsubscribe</a>
                
                &#183; <a href="javascipt:;" onclick="toggle('edit-title');return false;">Edit title</a>
                &#183; <a href="javascipt:;" onclick="toggle('add-tag');return false;">Add tag</a>
                &#183; <a href="<?php echo '?op=clear-cache'.$tqs.'&feed='.$current_feed['rss_url']; ?>">Force refresh</a>

                <div id="edit-title" style="display:none;">
                <form method="post">
                  <input type="text" value="<?php echo $current_feed['title']; ?>" id="new_title" name="new_title" />
                  <input type="hidden" value="<?php echo $current_feed['rss_url']; ?>" id="feed" name="feed" />
                  <input type="hidden" id="edit_title" name="edit_title" />
                  <input type="submit" value="Edit title" />
                </form>
                </div>
                
                <div id="add-tag" style="display:none;">
                <form method="post">
                  <input type="text" value="" id="newtag" name="newtag" />
                  <input type="hidden" value="<?php echo $current_feed['rss_url']; ?>" id="feed" name="feed" />
                  <input type="hidden" id="add_tag" name="add_tag" />
                  <input type="submit" value="Add tag" /> <?php if (count($tags) > 0) { ?> (<a href="javascript:;" onclick="toggle('ctags');return false;">current tags</a>)<?php } ?>
                </form>


<?php
if (count($tags) > 0) { ?>
			<p id="ctags" style="display:none;">
    <?php
    foreach ($tags as $tag) {
        echo '<a href="javascript:;" onclick="setInputValue(\'newtag\', \''.$tag.'\');return false;">'.$tag.'</a> &nbsp; '."\n";
    }
    ?>
            </p>
    <?php
}
?>
                </div>

                

                <?php } ?>

                </div>


				<!-- Let's begin looping through each individual news item in the feed. -->
				<?php $i=0; foreach($feed->get_items() as $item): ?>
					<div class="chunk">

						<!-- If the item has a permalink back to the original post (which 99% of them do), link the item's title to it. -->
						<h4><?php $i++; if ($item->get_permalink()) echo '<a href="http://www.google.com/url?sa=D&q=' . $item->get_permalink() . '">'; echo $item->get_title(); if ($item->get_permalink()) echo '</a>'; ?>&nbsp;<span class="footnote"><?php echo $item->get_date('j M Y'); ?> <a  href="javascript:;" onclick="toggle('item<?php echo $i; ?>');return false;">&#8595;&nbsp;Excerpt</a> <a href="#bukopie">&#8593;&nbsp;Top</a></span></h4>

						<!-- Display the item's primary content. -->
                        <div class="rss-excerpts" id="item<?php echo $i; ?>">
						<?php echo $item->get_description(); ?>
                        </div>

						<?php
						// Check for enclosures.  If an item has any, set the first one to the $enclosure variable.
						if ($enclosure = $item->get_enclosure(0)) {

							// Use the embed() method to embed the enclosure into the page inline.
							echo '<div align="center">';
							echo '<p>' . $enclosure->embed("audio:./for_the_demo/place_audio.png, video:./for_the_demo/place_video.png, alt:<img src='./for_the_demo/mini_podcast.png' class='download' border='0' title='Download the Podcast (" . $enclosure->get_extension() . "; " . $enclosure->get_size() . " MB)' />, altclass:download") . '</p>';
							echo '<p class="footnote" align="center">(' . $enclosure->get_type() . '; ' . $enclosure->get_size() . ' MB)</p>';
							echo '</div>';
						}
						?>

					</div>

				<!-- Stop looping through each item once we've gone through all of them. -->
				<?php endforeach; ?>

				<!-- </div> -->

			<!-- From here on, we're no longer using data from the feed. -->
			<?php endif; ?>

		</div>

		<div>


			<!-- Display the version of SimplePie being loaded. -->
			<p class="footnote">
            <a href="http://rebelpixel.com/projects/bukopie/">BukoPie <?php echo $rp_bukopie_version; ?></a>
            is WordPressed <a href="http://simplepie.org/">SimplePie</a>.
            Brought to you by <a href="http://www.skyzyx.com">Skyzyx Technologies</a>
            and <a href="http://rebelpixel.com/">rebelpixel productions</a>.
            </p>
		</div>






</div><!-- <div id="site"> -->
</div><!-- <div class="wrap" id="bukopie"> -->
<?php include_once '../../../wp-admin/admin-footer.php'; ?>