<?php
// 2006/07/28 12:56 AM


class BukoPie extends SimplePie
{
    function clear_cache_item()
    {
        $cache_filename = $this->cache_location . '/' . urlencode($this->rss_url) . '.spc';
		if (file_exists($cache_filename) ) {
            unlink($cache_filename);
		}
    }
}




class feeds
{
    // $array[tags]
    // $array[feeds]
    
    // $feeds
    // $feeds[[0]
    // $feeds[[0][rss_url]
    // $feeds[[0][title]
    // $feeds[[0][tags]
    var $file_array = array();
    var $feed_array = array();
    var $tag_array = array();
    var $t = '';

    function feeds()
    {
        //$this->t = new txt_storage;
        $this->t = new wp_storage;
    }

    function load($f)
    {
        $this->t->open($f);
        $this->file_array = $this->t->read();
        $this->tag_array = $this->file_array['tags'];
        $this->feed_array = $this->file_array['feeds'];
    }

    function add($new_item) // array($rss, $title, $tags)
    {
        if (strlen($new_item['rss_url']) > 0 && strlen($new_item['title']) > 0) {
            $this->feed_array[] = $new_item;
        }
        $this->_update_tags();
    }

    function get_feed($rss_url)
    {
        if (count($this->feed_array) > 0) {
            foreach ($this->feed_array as $feed) {
                if ($feed['rss_url'] == $rss_url) {
                    $_f = $feed;
                    break;
                }
            }
            return $_f;
        } else {
            return false;
        }
    }
    
    
    function get_all()
    {
        return $this->feed_array;
    }

    function get_feeds()
    {
        return $this->feed_array;
    }

    function get_tags()
    {
        return $this->tag_array;
    }

    function delete($rss_url)
    {
        foreach ($this->feed_array as $item) {
            if ($rss_url != $item['rss_url']) {
                $_new[] = $item;
            }
        }
        $this->feed_array = $_new;
        $this->_update_tags();
    }

    function update_title($feed_url, $new_title)
    {
        foreach ($this->feed_array as $feed) {
            if ($feed['rss_url'] == $feed_url) {
                $feed['title'] = $new_title;
                $_n[] = $feed;
            } else {
                $_n[] = $feed;
            }
        }
        $this->feed_array = $_n;
    }

    function add_tag($feed_url, $new_tag)
    {
        foreach ($this->feed_array as $feed) {
            if ($feed['rss_url'] == $feed_url) {
                if (!in_array($new_tag,$feed['tags'])) {
                    $feed['tags'][] = $new_tag;
                }
                $_n[] = $feed;
            } else {
                $_n[] = $feed;
            }
        }
        $this->feed_array = $_n;
        $this->_update_tags();
    }


    function remove_tag($feed_url, $delete_tag)
    {
        foreach ($this->feed_array as $feed) {
            if ($feed['rss_url'] == $feed_url) {
                if (in_array($delete_tag,$feed['tags'])) {
                    $_new_tags = array();
                    foreach ($feed['tags'] as $tag) {
                        if ($tag != $delete_tag) {
                            $_new_tags[] = $tag;
                        }
                    }
                    $feed['tags'] = $_new_tags;
                }
                $_n[] = $feed;
            } else {
                $_n[] = $feed;
            }
        }
        $this->feed_array = $_n;
        $this->_update_tags();
    }



    function save()
    {
        $this->file_array['tags'] = $this->tag_array;
        $this->file_array['feeds'] = $this->feed_array;
        $this->t->save($this->file_array);
    }

    function _update_tags()
    {
        $this->tag_array = array();
        foreach ($this->feed_array as $item) {
            if (count($item['tags']) > 0) {
                foreach ($item['tags'] as $tag) {
                    if (!in_array($tag, $this->tag_array)) {
                        $this->tag_array[] = $tag;
                    }
                }
            }
        }
        if (count($this->tag_array) > 0) {
            sort($this->tag_array);
        }
    }

} // class




class wp_storage extends txt_storage
{
    function open($f)
    {
        $this->contents = get_option('bukopiesubs');
    }

    function save($arr_data)
    {
        $this->contents = $arr_data;
        update_option('bukopiesubs', $this->contents);
    }
}






class txt_storage
{
    var $txtfile;
    var $contents;

    function txt_storage()
    {
        return true;
    }

    function open($f)
    {
        $this->txtfile = trim($f);
        $handle = fopen($this->txtfile, 'r');
        while (true) {
            $_c = fread($handle, 4096);
            $this->contents .= $_c;
            if (strlen($_c) == 0) {
                break;
            }
        }
        fclose($handle); 
        $this->_decode();
    }

    function read()
    {
        return $this->contents;
    }

    function _decode()
    {
        $this->contents = unserialize($this->contents);
    }

    function _encode()
    {
        $this->contents = serialize($this->contents);
    }

    function save($arr_data)
    {
        $this->contents = $arr_data;
        $this->_encode();
        $handle = fopen($this->txtfile, 'w'); 
        $this->contents = fwrite($handle, $this->contents);
        fclose($handle); 
    }

    function close()
    {
        return true;
    }
}

?>