<?php
/*
Plugin Name: BukoPie
Version: 0.1.5
Plugin URI: http://rebelpixel.com/projects/bukopie/
Description: <a href="http://rebelpixel.com/projects/bukopie/">BukoPie </a> is a feedreader based on <a href="http://simplepie.org/">SimplePie</a> and hacked into a WordPress plugin by Markku Seguerra of <a href="http://rebelpixel.com/">rebelpixel productions</a>.
Author: Markku Seguerra
Author URI: http://rebelpixel.com/
*/
            


$rp_bukopie_version = '0.1.5';

if (!function_exists('rp_bukopie_admin_menu')) {
    function rp_bukopie_admin_menu()
    {
        if ( function_exists('add_submenu_page') ) {
            //add_submenu_page('index.php', 'BukoPie', 'BukoPie', 5, 'bukopie.php');
		    add_submenu_page('index.php', 'BukoPie', 'BukoPie', 5, __FILE__, 'rp_bukopie_dashboard');
        }
    }
}


if (!function_exists('rp_bukopie_head')) {
    function rp_bukopie_head()
    {
        ob_start();
    }
}


if (!function_exists('rp_bukopie_foot')) {
    function rp_bukopie_foot()
    {
        global $wp_version;

        $out = ob_get_clean();
        //$out = str_replace('/wp-admin/bukopie.php', '/wp-content/plugins/bukopie/bukopie.php', $out);
        $out = str_replace('/wp-admin/index.php?page=bukopie/plugin.php', '/wp-content/plugins/bukopie/bukopie.php', $out);
        $s = get_settings('siteurl');
        if ($wp_version >= 2) {
            $out = str_replace('images/wordpress-logo.png', $s.'/wp-admin/images/wordpress-logo.png', $out);
        } else {
            $out = str_replace('../wp-images/wp-small.png', $s.'/wp-images/wp-small.png', $out);
        }
        if ( is_int(strpos($_SERVER['PHP_SELF'], 'bukopie.php')) ) {
            $out = str_replace("bukopie.php'", "bukopie.php' class='current'", $out);
        }
        /* echo $out."<!-- ".$_SERVER['PHP_SELF']." -->"; */
        echo $out;
    }
}





if (!function_exists('rp_bukopie_styles')) {
    function rp_bukopie_styles()
    {
        $s = get_settings('siteurl');
$css = <<<TEXT
<link rel="stylesheet" href="bukopie.css" type="text/css" />
<script type="text/javascript" src="bukopie-scripts.js"></script>
TEXT;

        echo $css;
    }
}








function rp_bukopie_dashboard() {
?>
<div class="wrap">
<h2>BukoPie</h2>
	<p><a href="http://rebelpixel.com/projects/bukopie/">BukoPie </a>
    is a feedreader based on <a href="http://simplepie.org/">SimplePie</a>
    and hacked into a WordPress plugin by Markku Seguerra of
    <a href="http://rebelpixel.com/">rebelpixel productions</a>.</p>

	<p>If you&#8217;re seeing this page, the menu replacement magic has
    failed. <strong>Here&#8217;s your
    <a href="../wp-content/plugins/bukopie/bukopie.php">BukoPie page.</a></strong></p>
</div>
<?php
}










add_filter('admin_head', 'rp_bukopie_styles', 999999);

add_action('admin_menu', 'rp_bukopie_admin_menu');
add_action('admin_head', 'rp_bukopie_head', 99999999999);
add_action('admin_footer', 'rp_bukopie_foot', 00000000000);
?>